#include <iostream>

#include <iomanip>

using namespace std;

int board[8][8] = {{0}};

int horizontal[] =	{2, 1, -1, -2, -2, -1, 1, 2};
int vertical[] =	{-1, -2, -2, -1, 1, 2, 2, 1};

bool validmove(int, int, int);

bool validmove(int movetype, int row, int col)
{
return ( (row+vertical[movetype] >= 0) &&
		 (row+vertical[movetype] < 8 ) &&
		 (col+horizontal[movetype] >= 0) &&
		 (col+horizontal[movetype] < 8 ) &&
		 board[(row+vertical[movetype])][(col+horizontal[movetype])]==0);
}

int main()
{
int currentRow = 7;
int currentColumn = 0;
int movecounter = 1;

board[currentRow][currentColumn] = movecounter;
while (movecounter <= 64)
	{
	int i;
	for (i=0; i<8; i++)
		if( validmove(i, currentRow, currentColumn) )
			{
			currentRow += vertical[i];
			currentColumn += horizontal[i];
			board[currentRow][currentColumn] = ++movecounter;
			break;		//after a valid move, does not continue
			} //end if
	if (i==8) break;
	} //end while

for (int i=0; i<8; i++)
	{
	for (int j=0; j<8; j++)
		cout << setw (3) << board[i][j];
	cout << endl << endl;
	} //end for

cout << movecounter;
} //end main